<template>
  <div class="antialiased sans-serif">
    <div class="relative w-max">
      <input
        type="text"
        readonly
        v-model="datePickerValue"
        @click="show = !show"
        @keydown.escape="show = false"
        class="Input"
        placeholder="Select date">
      <div class="absolute top-0 right-0 px-3 py-2">
        <svg class="h-5 w-5 text-gray-600"  fill="none" viewBox="0 0 24 24" stroke="currentColor">
          <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M8 7V3m8 4V3m-9 8h10M5 21h14a2 2 0 002-2V7a2 2 0 00-2-2H5a2 2 0 00-2 2v12a2 2 0 002 2z"/>
        </svg>
      </div>
      <div
          class="bg-white mt-12 rounded-lg shadow p-4 absolute top-0 left-0"
          style="width: 17rem"
          v-show="show">
          <div class="flex justify-between items-center mb-2">
            <div>
              <span class="text-lg font-bold text-gray-800">{{MONTH_NAMES[month]}}</span>
              <span class="ml-1 text-lg text-gray-600 font-normal">{{year}}</span>
            </div>
            <div>
              <button
                type="button"
                class="transition ease-in-out duration-100 inline-flex cursor-pointer hover:bg-gray-200 p-1 rounded-full"
                @click="month--; getNoOfDays()">
                <svg class="h-6 w-6 text-gray-500 inline-flex"  fill="none" viewBox="0 0 24 24" stroke="currentColor">
                  <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 19l-7-7 7-7"/>
                </svg>
              </button>
                <button
                  type="button"
                  class="transition ease-in-out duration-100 inline-flex cursor-pointer hover:bg-gray-200 p-1 rounded-full"
                  @click="month++; getNoOfDays()">
                  <svg class="h-6 w-6 text-gray-500 inline-flex"  fill="none" viewBox="0 0 24 24" stroke="currentColor">
                    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7"/>
                  </svg>
                </button>
            </div>
          </div>
          <div class="grid grid-cols-7 gap-y-6 gap-x-4">
            <div v-for="day in DAYS" :key="day">
              <p class="text-gray-800 font-medium text-center text-xs">{{day}}</p>
            </div>
            <div v-for="blankday in blankdays" :key="blankday">
            </div>
            <div v-for="date in no_of_days" :key="date">
              <div
                  @click="setDate(date)"
                  class="cursor-pointer text-center text-sm leading-none rounded-full leading-loose transition ease-in-out duration-100"
              >
                {{date}}
              </div>
            </div>
          </div>
        </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'DatePicker',
  props: ['update'],
  data () {
    return {
      MONTH_NAMES: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
      DAYS: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
      show: false,
      datePickerValue: '',
      value: '',
      month: '',
      year: '',
      no_of_days: [],
      blankdays: [],
      date: ''
    }
  },
  computed: {
    isToday (date) {
      const today = new Date()
      const d = new Date(this.year, this.month, date)
      return today.toDateString() === d.toDateString()
    }
  },
  methods: {
    setDate (date) {
      const selectedDate = new Date(this.year, this.month, date)
      this.datePickerValue = selectedDate.toDateString()
      this.value = selectedDate.getFullYear() + '-' + ('0' + (Number(selectedDate.getMonth()) + 1)).slice(-2) + '-' + ('0' + selectedDate.getDate()).slice(-2)
      this.show = false
      this.update(this.value)
    },
    getNoOfDays () {
      const daysInMonth = new Date(this.year, this.month + 1, 0).getDate()

      // find where to start calendar day of week
      const dayOfWeek = new Date(this.year, this.month).getDay()
      const blankdaysArray = []
      for (let i = 1; i <= dayOfWeek; i++) {
        blankdaysArray.push(i + 100)
      }

      const daysArray = []
      for (let i = 1; i <= daysInMonth; i++) {
        daysArray.push(i)
      }

      this.blankdays = blankdaysArray
      this.no_of_days = daysArray
    }
  },
  beforeMount () {
    const today = new Date()
    this.month = today.getMonth()
    this.year = today.getFullYear()
    this.value = new Date(this.year, this.month, today.getDate()).toDateString()
    this.getNoOfDays()
  }
}
</script>

<style lang="postcss" scoped>
.Input {
  @apply appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md shadow-sm focus:ring-yellow-500 focus:border-yellow-500;
}

.Input:focus {
  @apply outline-none;
}

@screen sm {
  .Input {
    @apply text-sm;
  }
}
</style>
